Wishlist: reCAPTCHA support

Bug #1252098 reported by Aaron Wells on 2013-11-17
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Mahara
Wishlist
Aaron Wells

Bug Description

As part of https://bugs.launchpad.net/mahara/+bug/1250641 , I've implemented reCAPTCHA support for the user self-registration page, and deployed it to mahara.org. This is a bug to track that specific feature.

Aaron Wells (u-aaronw) wrote :

I implemented this and deployed it to mahara.org for around a week. There weren't any reports of problems; on the other hand, it also didn't stop our spam problems (which apparently were caused by human beings posting spam), so we disabled it.

If anyone's interested, I've cherry-picked the code onto the "recaptcha" branch on my personal gitorious mahara repo. I'll try to upstream it for 1.9.0: https://gitorious.org/mahara/agwells-mahara/source/16da498ab7d7f73d37cad25d3a8f8c4ceda7fbf0:

Changed in mahara:
milestone: none → 1.9.0

Aaron, do you want to keep reCaptcha as site option or leave it out? Your other spam protection settings seem to work much better.

Aaron Wells (u-aaronw) wrote :

Hi Kristina,

Yeah, I'm not sure. It certainly didn't stop our spammers. On the other hand, it might work for someone? But on the third hand, upstreaming it means that we'd also have to field bug reports about it when it stops working because the service has changed.

Perhaps if anyone from the community expresses interest in using this, we can upstream it.

Cheers,
Aaron

I would leave this as a plugin and not upstream at this stage as only your other measures were successful. We used to have Captcha and took it out some years ago for accessibility reasons. Maybe reCaptcha is probably better as you do have accessibility options, but it hasn't really helped cope with the spam volume. So I think it might not be useful and only give users peace of mind to have Captcha like on their other pages, but not really add value.

Aaron Wells (u-aaronw) wrote :

We wound up re-adding reCaptcha to mahara.org after receiving a slew of automatically generated registrations. Deploying reCaptcha put a stop to those.

Since it's deployed to mahara.org, I've also submitted it for upstream: https://reviews.mahara.org/3054

(There's also an earlier version, split into three patches, starting at https://reviews.mahara.org/3013 )

Mahara Bot (dev-mahara) wrote :

Patch for "master" branch: https://reviews.mahara.org/3055

Mahara Bot (dev-mahara) wrote :

Patch for "master" branch: https://reviews.mahara.org/3056

Aaron Wells (u-aaronw) wrote :

So to clarify, I split up my one patch into three patches in order to have a separate commit for the recaptcha 3rd party library. So now there is:

1. https://reviews.mahara.org/3055 - Adding the recaptcha 3rd party library
2. https://reviews.mahara.org/3056 - Patching the recaptcha 3rd party library
3. https://reviews.mahara.org/3054 - The code to use recaptcha during user registration

Mahara Bot (dev-mahara) wrote :

Patch for "master" branch: https://reviews.mahara.org/3063

Mahara Bot (dev-mahara) wrote :

Patch for "master" branch: https://reviews.mahara.org/3062

Aaron Wells (u-aaronw) wrote :

Okay, I refactored the "captcha" element into a pieform element and added support for internationalization to it. This is still a minor change but in order to keep the commits well-formed I've split it into 5 parts. They're all tagged under topic "recaptcha": https://reviews.mahara.org/#/q/status:open+project:mahara+branch:master+topic:recaptcha,n,z

1. https://reviews.mahara.org/3062 - Alters Pieforms to add a hook for a pieform element to remove itself from Pieforms (so that the captcha pieform element won't display unless captchas are enabled)

2. https://reviews.mahara.org/3055 - Adding the recaptcha 3rd party library

3. https://reviews.mahara.org/3056 - Patching the recaptcha 3rd party library to use protocol-relative URLs

4. https://reviews.mahara.org/3062 - Patching the rectapcha 3rd party library to use Mahara's current language

3. https://reviews.mahara.org/3054 - Defining the "captcha" pieform element and adding it to the user registration page

Reviewed: https://reviews.mahara.org/3062
Committed: http://gitorious.org/mahara/mahara/commit/1e99a42639110e1b9d560630a64a88403f8a43db
Submitter: Robert Lyon (<email address hidden>)
Branch: master

commit 1e99a42639110e1b9d560630a64a88403f8a43db
Author: Aaron Wells <email address hidden>
Date: Mon Mar 3 16:23:45 2014 +1300

Add a hook to allow a pieform element to remove itself from a form

Bug 1252098

Change-Id: I594089dc142adaf69e67da2858e9e8b2a235cec7

Mahara Bot (dev-mahara) wrote :

Reviewed: https://reviews.mahara.org/3055
Committed: http://gitorious.org/mahara/mahara/commit/113a9ac9c5755e92b0787a0885086f77dec970ba
Submitter: Robert Lyon (<email address hidden>)
Branch: master

commit 113a9ac9c5755e92b0787a0885086f77dec970ba
Author: Aaron Wells <email address hidden>
Date: Fri Feb 28 16:37:25 2014 +1300

Adding the reCAPTCHA PHP library.

Bug 1252098

Change-Id: I3aefb5a85568177d3f2f82b252841ee1a34603ef

Mahara Bot (dev-mahara) wrote :

Reviewed: https://reviews.mahara.org/3056
Committed: http://gitorious.org/mahara/mahara/commit/72ace3186966032e875a17d15d08c2c18aa1de78
Submitter: Robert Lyon (<email address hidden>)
Branch: master

commit 72ace3186966032e875a17d15d08c2c18aa1de78
Author: Aaron Wells <email address hidden>
Date: Fri Feb 28 16:44:30 2014 +1300

Change the reCAPTCHA PHP library to use a protocol-relative URL for the iframe

Bug 1252098

Change-Id: I9be9290ca643e1da1786c4008de4a5e0501fb32b

Mahara Bot (dev-mahara) wrote :

Reviewed: https://reviews.mahara.org/3063
Committed: http://gitorious.org/mahara/mahara/commit/a68681d803fbab44a481db6f17d30a52e84529ca
Submitter: Robert Lyon (<email address hidden>)
Branch: master

commit a68681d803fbab44a481db6f17d30a52e84529ca
Author: Aaron Wells <email address hidden>
Date: Mon Mar 3 16:28:31 2014 +1300

Change the ReCAPTCHA PHP library to use Mahara languages

Bug 1252098

Change-Id: I1034a6a9ddd477c3f8e909a707cae637337708fb

Mahara Bot (dev-mahara) wrote :

Reviewed: https://reviews.mahara.org/3054
Committed: http://gitorious.org/mahara/mahara/commit/c2e3e308467b9da315d0c2c1ef3a5d98f3a7e8ee
Submitter: Robert Lyon (<email address hidden>)
Branch: master

commit c2e3e308467b9da315d0c2c1ef3a5d98f3a7e8ee
Author: Aaron Wells <email address hidden>
Date: Thu Nov 14 22:29:10 2013 +1300

Adding reCAPTCHA support to user self-registration page

Bug 1252098

Change-Id: I9f2386fcb69510a23f66efc3bce32697fb8c8616

Robert Lyon (robertl-9) on 2014-03-12
Changed in mahara:
status: In Progress → Fix Committed
Robert Lyon (robertl-9) on 2014-04-22
Changed in mahara:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers